Curl.global_init Curl.CURLINIT_GLOBALALL;;
at_exit Curl.global_cleanup;;

let writer accum data =
  Buffer.add_string accum data;
  String.length data

let showContent content =
  Printf.printf "%s" (Buffer.contents content);
  flush stdout

let cmd = Sys.argv.(1);; (* dele mkd rmd ... *)
let url = Sys.argv.(2);;

let dir, file = (
  if cmd = "ls" then url, "" else
  Filename.dirname url ^ "/", Filename.basename url
);;

let result = Buffer.create 16384
and errorBuffer = ref "" in
begin try
  let connection = Curl.init () in
  Curl.set_errorbuffer connection errorBuffer;
  Curl.set_writefunction connection (writer result);
  Curl.set_followlocation connection true;
  Curl.set_url connection dir;
  if cmd <> "ls" then (
    Curl.set_postquote connection [cmd ^ " " ^ file]
  );
  Curl.perform connection;
  if cmd = "ls" then showContent result;
  Curl.cleanup connection
with
| Curl.CurlException (_, code, str) ->
  Printf.fprintf stderr "Error: [%s] %s\n" str !errorBuffer
| Failure s ->
  Printf.fprintf stderr "Caught exception: %s\n" s
end;;
