#if defined(__MSVCRT__)
#include <sys/utime.h>
#else
#include <utime.h>
#endif

#include <stdbool.h>

#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/alloc.h>
#include <caml/fail.h>

CAMLprim value mlutimes(value filename, value atime, value mtime)
{
	CAMLparam3(filename, atime, mtime);
	bool error;
#if defined(__MSVCRT_VERSION__) && __MSVCRT_VERSION__ >= 0x0601
	struct __utimbuf64 times;
	times.actime = Double_val(atime);
	times.modtime = Double_val(mtime);
	error = _utime64(String_val(filename), &times);
#else
	struct utimbuf times;
	times.actime = Double_val(atime);
	times.modtime = Double_val(mtime);
	error = utime(String_val(filename), &times);
#endif
	if(error){
		caml_raise_sys_error(caml_copy_string("mlutimes"));
	}
	CAMLreturn(Val_unit);
}
